> This page is for Itential Platform Cloud.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs-test.itntl.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs-test.itntl.com/_mcp/server.

# Import automations

PUT https://example.itential.io/operations-manager/automations
Content-Type: application/json

Imports Automations.

Reference: https://docs-test.itntl.com/itential-cloud/api-reference/operations-manager/import-automations

## Authentication

- `Authorization` header (basic auth, required) — Basic authentication of the form `Basic <base64(username:password)>`.

## Request

### Body (application/json)

This endpoint expects an object.

- `automations` (list of operations-manager_automation-json, optional)
- `options` (OperationsManagerAutomationsPutRequestBodyContentApplicationJsonSchemaOptions, optional)

## Response

### 200

The result of the import operation.

- `message` (string, required) — A human-readable message summarizing the result of the operation
- `data` (list of OperationsManagerAutomationsPutResponsesContentApplicationJsonSchemaDataItems, required) — Any successfully retrieved information related to the request.
- `metadata` (map from string to any, required) — Any structured, wordy or machine-readable information related to the result of the operation. For success responses, this may contain information like pagination values from a search operation.

## Errors

### 500 Internal Server Error

Error response from API

- `any`

## Types

### operations-manager_automation-json

An Automation document in JSON/export format.

- `name` (string, required) — The name of the document
- `description` (string, required) — The description of the document
- `componentType` (OperationsManagerAutomationJsonComponentType, required, nullable) — The type of component linked to this Automation.
- `_id` (string, required) — A string which is formatted like an ObjectId, Distinct from an actual ObjectId.
- `gbac` (OperationsManagerAutomationJsonGbac, required)
- `componentName` (string, required, nullable) — The name of the component linked to this Automation.
- `createdBy` (string, optional, nullable)
- `created` (string, optional) — An ISO 8601 date string
- `lastUpdatedBy` (string, optional, nullable)
- `lastUpdated` (string, optional) — An ISO 8601 date string
- `triggers` (list of OperationsManagerAutomationJsonTriggersItems, optional)

### OperationsManagerAutomationsPutRequestBodyContentApplicationJsonSchemaOptions

- `adapterMap` (OperationsManagerAutomationsPutRequestBodyContentApplicationJsonSchemaOptionsAdapterMap, optional) — A mapping of provenance names to be converted upon import, specified in "old_name": "new_name" format.

### OperationsManagerAutomationsPutResponsesContentApplicationJsonSchemaDataItems

- `success` (boolean, optional)
- `data` (OperationsManagerAutomationsPutResponsesContentApplicationJsonSchemaDataItemsData, optional)

### OperationsManagerAutomationJsonComponentType

The type of component linked to this Automation.

### OperationsManagerAutomationJsonGbac

- `write` (list of OperationsManagerAutomationJsonGbacWriteItems, required) — An array of group objects that have write access to the Automation.
- `read` (list of OperationsManagerAutomationJsonGbacReadItems, required) — An array of group objects that have read/execute access to the Automation.

### OperationsManagerAutomationJsonTriggersItems

### OperationsManagerAutomationsPutRequestBodyContentApplicationJsonSchemaOptionsAdapterMap

A mapping of provenance names to be converted upon import, specified in "old_name": "new_name" format.

### OperationsManagerAutomationsPutResponsesContentApplicationJsonSchemaDataItemsData

- `name` (string, optional) — The name of the document
- `description` (string, optional) — The description of the document
- `componentType` (OperationsManagerAutomationsPutResponsesContentApplicationJsonSchemaDataItemsDataComponentType, optional, nullable) — The type of component linked to this Automation.
- `createdBy` (OperationsManagerAutomationsPutResponsesContentApplicationJsonSchemaDataItemsDataCreatedBy, optional)
- `created` (string, optional) — An ISO 8601 date string
- `lastUpdatedBy` (OperationsManagerAutomationsPutResponsesContentApplicationJsonSchemaDataItemsDataLastUpdatedBy, optional)
- `lastUpdated` (string, optional) — An ISO 8601 date string
- `_id` (string, optional) — A string which is formatted like an ObjectId, Distinct from an actual ObjectId.
- `gbac` (operations-manager_automation-common_gbac, optional)
- `componentId` (OperationsManagerAutomationCommonComponentId, optional, nullable) — The id of the component linked to this Automation.

### OperationsManagerAutomationJsonGbacWriteItems

- `provenance` (string, required)
- `name` (string, required)
- `description` (string, required)

### OperationsManagerAutomationJsonGbacReadItems

- `provenance` (string, required)
- `name` (string, required)
- `description` (string, required)

### Endpoint Trigger

An Endpoint Trigger in JSON/export format.

- `name` (string, required) — The name of the document
- `enabled` (boolean, required) — A flag to determine if this Trigger is enabled or not.
- `actionType` (enum, required) — The type of component this Trigger will invoke.
  - Allowed values: `automations`
- `actionId` (string, required) — A string which is formatted like an ObjectId, Distinct from an actual ObjectId.
- `type` (any, required)
- `verb` (any, required)
- `routeName` (string, required) — User defined route name.
- `schema` (OperationsManagerAutomationJsonTriggersItemsOneOf0Schema, required, nullable) — POST body filter schema.
- `_id` (string, required) — A string which is formatted like an ObjectId, Distinct from an actual ObjectId.
- `jst` (OperationsManagerAutomationJsonTriggersItemsOneOf0Jst, required)
- `description` (string, optional) — The description of the document
- `options` (OperationsManagerAutomationJsonTriggersItemsOneOf0Options, optional) — Configuration options specific to this trigger.
- `lastExecuted` (integer, optional, nullable) — A timestamp in milliseconds of the time this Trigger was last executed.
- `migrationVersion` (integer, optional) — The current document version of this document.
- `createdBy` (string, optional, nullable)
- `created` (string, optional) — An ISO 8601 date string
- `lastUpdatedBy` (string, optional, nullable)
- `lastUpdated` (string, optional) — An ISO 8601 date string

### EventSystem Trigger

An EventSystem Trigger in JSON/export format.

- `name` (string, required) — The name of the document
- `enabled` (boolean, required) — A flag to determine if this Trigger is enabled or not.
- `actionType` (enum, required) — The type of component this Trigger will invoke.
  - Allowed values: `automations`
- `actionId` (string, required) — A string which is formatted like an ObjectId, Distinct from an actual ObjectId.
- `type` (any, required)
- `source` (string, required) — The source of the event.
- `topic` (string, required) — The event topic.
- `schema` (OperationsManagerAutomationJsonTriggersItemsOneOf1Schema, required, nullable) — Event payload filter schema.
- `_id` (string, required) — A string which is formatted like an ObjectId, Distinct from an actual ObjectId.
- `jst` (OperationsManagerAutomationJsonTriggersItemsOneOf1Jst, required)
- `description` (string, optional) — The description of the document
- `options` (OperationsManagerAutomationJsonTriggersItemsOneOf1Options, optional) — Configuration options specific to this trigger.
- `lastExecuted` (integer, optional, nullable) — A timestamp in milliseconds of the time this Trigger was last executed.
- `migrationVersion` (integer, optional) — The current document version of this document.
- `legacyWrapper` (boolean, optional) — A boolean determining whether payload data is wrapped in a 'payload' property
- `createdBy` (string, optional, nullable)
- `created` (string, optional) — An ISO 8601 date string
- `lastUpdatedBy` (string, optional, nullable)
- `lastUpdated` (string, optional) — An ISO 8601 date string

### Manual Trigger

A Manual Trigger in JSON/export format.

- `name` (string, required) — The name of the document
- `enabled` (boolean, required) — A flag to determine if this Trigger is enabled or not.
- `actionType` (enum, required) — The type of component this Trigger will invoke.
  - Allowed values: `automations`
- `actionId` (string, required) — A string which is formatted like an ObjectId, Distinct from an actual ObjectId.
- `type` (any, required)
- `formData` (OperationsManagerAutomationJsonTriggersItemsOneOf2FormData, required, nullable) — A JSON object created by filling out the associated JSON Form.
- `_id` (string, required) — A string which is formatted like an ObjectId, Distinct from an actual ObjectId.
- `formId` (OperationsManagerAutomationJsonTriggersItemsOneOf2FormId, required, nullable) — The name or id of a JSON Form used to provide inputs to a job from this trigger.
- `description` (string, optional) — The description of the document
- `options` (OperationsManagerAutomationJsonTriggersItemsOneOf2Options, optional) — Configuration options specific to this trigger.
- `lastExecuted` (integer, optional, nullable) — A timestamp in milliseconds of the time this Trigger was last executed.
- `migrationVersion` (integer, optional) — The current document version of this document.
- `createdBy` (string, optional, nullable)
- `created` (string, optional) — An ISO 8601 date string
- `lastUpdatedBy` (string, optional, nullable)
- `lastUpdated` (string, optional) — An ISO 8601 date string
- `formSchemaHash` (string, optional, nullable)
- `legacyWrapper` (boolean, optional) — A boolean determining whether form data is wrapped in a 'formData' property

### Schedule Triggers Schema for JSON Representation

Schema for a Schedule Trigger JSON representation

- `name` (string, required) — The name of the document
- `enabled` (boolean, required) — A flag to determine if this Trigger is enabled or not.
- `actionType` (enum, required) — The type of component this Trigger will invoke.
  - Allowed values: `automations`
- `actionId` (string, required) — A string which is formatted like an ObjectId, Distinct from an actual ObjectId.
- `type` (any, required)
- `formData` (OperationsManagerAutomationJsonTriggersItemsOneOf3FormData, required, nullable) — A JSON object created by filling out the associated JSON Form.
- `firstRunAt` (integer, required) — A timestamp in milliseconds for the first scheduled run of this Trigger.
- `processMissedRuns` (enum, required) — Describes how any missed job runs should be processed. A missed run is a job that was supposed to be ran at least 'n' seconds ago, but did not due to some issue with IAP (busy process, IAP was down, etc). 'none' means do not run any missed jobs. 'last' means only run the last missed job.
  - Allowed values: `none`, `last`
- `repeatInterval` (integer, required, nullable) — The interval between repeated jobs in milliseconds. This is calculated from repeatUnit and repeatFrequency.
- `_id` (string, required) — A string which is formatted like an ObjectId, Distinct from an actual ObjectId.
- `formId` (OperationsManagerAutomationJsonTriggersItemsOneOf3FormId, required, nullable) — The name or id of a JSON Form used to provide inputs to a job from this trigger.
- `description` (string, optional) — The description of the document
- `options` (OperationsManagerAutomationJsonTriggersItemsOneOf3Options, optional) — Configuration options specific to this trigger.
- `lastExecuted` (integer, optional, nullable) — A timestamp in milliseconds of the time this Trigger was last executed.
- `migrationVersion` (integer, optional) — The current document version of this document.
- `createdBy` (string, optional, nullable)
- `created` (string, optional) — An ISO 8601 date string
- `lastUpdatedBy` (string, optional, nullable)
- `lastUpdated` (string, optional) — An ISO 8601 date string
- `formSchemaHash` (string, optional, nullable)
- `legacyWrapper` (boolean, optional) — A boolean determining whether form data is wrapped in a 'formData' property
- `nextRunAt` (integer, optional, nullable) — A timestamp in milliseconds for the next scheduled run of this Trigger.
- `lastIntervalStart` (integer, optional, nullable) — A millisecond resolution timestamp denoting when the current run interval started. This is calculated using repeatEnd.
- `locked` (boolean, optional) — backend use only
- `waitFlag` (boolean, optional) — Deprecated, backend use only
- `repeat` (OperationsManagerAutomationJsonTriggersItemsOneOf3Repeat, optional, nullable) — A repetition pattern expressed as a tree of parent and child interval definitions.
- `repeatUnit` (any, optional)
- `repeatFrequency` (any, optional)

### OperationsManagerAutomationsPutResponsesContentApplicationJsonSchemaDataItemsDataComponentType

The type of component linked to this Automation.

### OperationsManagerAutomationsPutResponsesContentApplicationJsonSchemaDataItemsDataCreatedBy

### OperationsManagerAutomationsPutResponsesContentApplicationJsonSchemaDataItemsDataLastUpdatedBy

### operations-manager_automation-common_gbac

- `write` (list of string, required) — An array of group ids that have write access to the Automation.
- `read` (list of string, required) — An array of group ids that have read/execute access to the Automation.

### OperationsManagerAutomationCommonComponentId

The id of the component linked to this Automation.

### OperationsManagerAutomationJsonTriggersItemsOneOf0Schema

POST body filter schema.

### OperationsManagerAutomationJsonTriggersItemsOneOf0Jst

### OperationsManagerAutomationJsonTriggersItemsOneOf0Options

Configuration options specific to this trigger.

- `targetType` (enum, optional, nullable)
  - Allowed values: `instance`, `group`
- `targetIdentifier` (string, optional, nullable)
- `chooseTargetAtRuntime` (boolean, optional)
- `actionId` (string, optional) — A 4-digit hexadecimal id

### OperationsManagerAutomationJsonTriggersItemsOneOf1Schema

Event payload filter schema.

### OperationsManagerAutomationJsonTriggersItemsOneOf1Jst

### OperationsManagerAutomationJsonTriggersItemsOneOf1Options

Configuration options specific to this trigger.

- `targetType` (enum, optional, nullable)
  - Allowed values: `instance`, `group`
- `targetIdentifier` (string, optional, nullable)
- `chooseTargetAtRuntime` (boolean, optional)
- `actionId` (string, optional) — A 4-digit hexadecimal id

### OperationsManagerAutomationJsonTriggersItemsOneOf2FormData

A JSON object created by filling out the associated JSON Form.

### OperationsManagerAutomationJsonTriggersItemsOneOf2FormId

The name or id of a JSON Form used to provide inputs to a job from this trigger.

### OperationsManagerAutomationJsonTriggersItemsOneOf2Options

Configuration options specific to this trigger.

- `targetType` (enum, optional, nullable)
  - Allowed values: `instance`, `group`
- `targetIdentifier` (string, optional, nullable)
- `chooseTargetAtRuntime` (boolean, optional)
- `actionId` (string, optional) — A 4-digit hexadecimal id

### OperationsManagerAutomationJsonTriggersItemsOneOf3FormData

A JSON object created by filling out the associated JSON Form.

### OperationsManagerAutomationJsonTriggersItemsOneOf3FormId

The name or id of a JSON Form used to provide inputs to a job from this trigger.

### OperationsManagerAutomationJsonTriggersItemsOneOf3Options

Configuration options specific to this trigger.

- `targetType` (enum, optional, nullable)
  - Allowed values: `instance`, `group`
- `targetIdentifier` (string, optional, nullable)
- `chooseTargetAtRuntime` (boolean, optional)
- `actionId` (string, optional) — A 4-digit hexadecimal id

### OperationsManagerAutomationJsonTriggersItemsOneOf3Repeat

A repetition pattern expressed as a tree of parent and child interval definitions.

### OperationsManagerAutomationJsonTriggersItemsOneOf0JstOneOf0

### OperationsManagerAutomationJsonTriggersItemsOneOf1JstOneOf0

### OperationsManagerAutomationJsonTriggersItemsOneOf3Repeat0

- `type` (enum, optional)
  - Allowed values: `repeating`, `terminating`
- `duration` (OperationsManagerAutomationJsonTriggersItemsOneOf3RepeatOneOf0Duration, optional)
- `action` (enum, optional)
  - Allowed values: `execute`, `wait`
- `components` (list of any, optional)

### OperationsManagerAutomationJsonTriggersItemsOneOf3Repeat1

- `components` (list of any, required)
- `type` (any, optional)
- `start` (string, optional) — An ISO 8601 date string
- `end` (string, optional) — An ISO 8601 date string

### OperationsManagerAutomationJsonTriggersItemsOneOf3Repeat2

- `type` (any, optional)
- `duration` (OperationsManagerAutomationJsonTriggersItemsOneOf3RepeatOneOf2Duration, optional)
- `count` (integer, optional)
- `action` (enum, optional)
  - Allowed values: `execute`, `wait`
- `components` (list of any, optional)

### OperationsManagerAutomationJsonTriggersItemsOneOf3RepeatOneOf0Duration

### OperationsManagerAutomationJsonTriggersItemsOneOf3RepeatOneOf2Duration

### OperationsManagerAutomationJsonTriggersItemsOneOf3RepeatOneOf0Duration0

- `unit` (any, optional)
- `quantity` (double, optional)

### OperationsManagerAutomationJsonTriggersItemsOneOf3RepeatOneOf0Duration1

- `unit` (enum, optional)
  - Allowed values: `minute`, `hour`, `day`, `week`
- `quantity` (integer, optional)

### OperationsManagerAutomationJsonTriggersItemsOneOf3RepeatOneOf2Duration0

- `unit` (any, optional)
- `quantity` (double, optional)

### OperationsManagerAutomationJsonTriggersItemsOneOf3RepeatOneOf2Duration1

- `unit` (enum, optional)
  - Allowed values: `minute`, `hour`, `day`, `week`
- `quantity` (integer, optional)

## Examples

**Request**

```json
{}
```

**Response**

```json
{
  "message": "Successfully created the requested item",
  "data": [
    {
      "success": true,
      "data": {
        "name": "Cisco IOS upgrade",
        "description": "Turn up the port",
        "componentType": null,
        "createdBy": null,
        "created": "2024-01-15T09:30:00Z",
        "lastUpdatedBy": null,
        "lastUpdated": "2024-01-15T09:30:00Z",
        "_id": "string",
        "gbac": {
          "write": [
            "string"
          ],
          "read": [
            "string"
          ]
        },
        "componentId": "string"
      }
    }
  ],
  "metadata": {}
}
```

**SDK Code**

```python
import requests

url = "https://example.itential.io/operations-manager/automations"

payload = {}
headers = {"Content-Type": "application/json"}

response = requests.put(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://example.itential.io/operations-manager/automations';
const options = {method: 'PUT', headers: {'Content-Type': 'application/json'}, body: '{}'};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://example.itential.io/operations-manager/automations"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://example.itential.io/operations-manager/automations")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://example.itential.io/operations-manager/automations")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://example.itential.io/operations-manager/automations', [
  'body' => '{}',
  'headers' => [
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://example.itential.io/operations-manager/automations");
var request = new RestRequest(Method.PUT);
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Content-Type": "application/json"]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://example.itential.io/operations-manager/automations")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```